<?php

namespace App\Http\Controllers\User;

use App\Constants\Status;
use App\Http\Controllers\Controller;
use App\Lib\GoogleAuthenticator;
use App\Models\DeviceToken;
use App\Models\Subcategory;
use App\Models\Card;
use App\Models\AdminNotification;
use App\Models\SupportTicket;
use App\Models\Transaction;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\Rule;
use Carbon\Carbon;

class UserController extends Controller
{
    public function home()
    {
        $pageTitle = 'Dashboard';
        $user = auth()->user();
        $latestTrx = Transaction::where('user_id', $user->id)->latest()->limit(10)->get();
        $totalCard = Card::where('user_id', $user->id)->count();
        $totalTrx = Transaction::where('user_id', $user->id)->count();
        $totalTicket = SupportTicket::where('user_id', $user->id)->count();
        return view('Template::user.dashboard', compact('pageTitle', 'latestTrx', 'totalCard', 'totalTrx', 'totalTicket', 'user'));
    }

    public function depositHistory(Request $request)
    {
        $pageTitle = 'Deposit History';
        $deposits = auth()->user()->deposits()->searchable(['trx'])->with(['gateway'])->orderBy('id', 'desc')->paginate(getPaginate());
        return view('Template::user.deposit_history', compact('pageTitle', 'deposits'));
    }

    public function show2faForm()
    {
        $ga = new GoogleAuthenticator();
        $user = auth()->user();
        $secret = $ga->createSecret();
        $qrCodeUrl = $ga->getQRCodeGoogleUrl($user->username . '@' . gs('site_name'), $secret);
        $pageTitle = '2FA Security';
        return view('Template::user.twofactor', compact('pageTitle', 'secret', 'qrCodeUrl'));
    }

    public function create2fa(Request $request)
    {
        $user = auth()->user();
        $request->validate([
            'key' => 'required',
            'code' => 'required',
        ]);
        $response = verifyG2fa($user, $request->code, $request->key);
        if ($response) {
            $user->tsc = $request->key;
            $user->ts = Status::ENABLE;
            $user->save();
            $notify[] = ['success', 'Two factor authenticator activated successfully'];
            return back()->withNotify($notify);
        } else {
            $notify[] = ['error', 'Wrong verification code'];
            return back()->withNotify($notify);
        }
    }

    public function disable2fa(Request $request)
    {
        $request->validate([
            'code' => 'required',
        ]);

        $user = auth()->user();
        $response = verifyG2fa($user, $request->code);
        if ($response) {
            $user->tsc = null;
            $user->ts = Status::DISABLE;
            $user->save();
            $notify[] = ['success', 'Two factor authenticator deactivated successfully'];
        } else {
            $notify[] = ['error', 'Wrong verification code'];
        }
        return back()->withNotify($notify);
    }

    public function transactions()
    {
        $pageTitle = 'Transactions';
        $remarks = Transaction::distinct('remark')->orderBy('remark')->get('remark');

        $transactions = Transaction::where('user_id', auth()->id())->searchable(['trx'])->filter(['trx_type', 'remark'])->orderBy('id', 'desc')->paginate(getPaginate());

        return view('Template::user.transactions', compact('pageTitle', 'transactions', 'remarks'));
    }

    public function userData()
    {
        $user = auth()->user();

        if ($user->profile_complete == Status::YES) {
            return to_route('user.home');
        }

        $pageTitle  = 'User Data';
        $info       = json_decode(json_encode(getIpInfo()), true);
        $mobileCode = @implode(',', $info['code']);
        $countries  = json_decode(file_get_contents(resource_path('views/partials/country.json')));

        return view('Template::user.user_data', compact('pageTitle', 'user', 'countries', 'mobileCode'));
    }

    public function userDataSubmit(Request $request)
    {

        $user = auth()->user();

        if ($user->profile_complete == Status::YES) {
            return to_route('user.home');
        }

        $countryData  = (array)json_decode(file_get_contents(resource_path('views/partials/country.json')));
        $countryCodes = implode(',', array_keys($countryData));
        $mobileCodes  = implode(',', array_column($countryData, 'dial_code'));
        $countries    = implode(',', array_column($countryData, 'country'));

        $request->validate([
            'country_code' => 'required|in:' . $countryCodes,
            'country'      => 'required|in:' . $countries,
            'mobile_code'  => 'required|in:' . $mobileCodes,
            'username'     => 'required|unique:users|min:6',
            'mobile'       => ['required', 'regex:/^([0-9]*)$/', Rule::unique('users')->where('dial_code', $request->mobile_code)],
        ]);

        $user->country_code = $request->country_code;
        $user->mobile       = $request->mobile;
        $user->username     = $request->username;


        $user->address = $request->address;
        $user->city = $request->city;
        $user->state = $request->state;
        $user->zip = $request->zip;
        $user->country_name = @$request->country;
        $user->dial_code = $request->mobile_code;

        $user->profile_complete = Status::YES;
        $user->save();

        return to_route('user.home');
    }


    public function addDeviceToken(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'token' => 'required',
        ]);

        if ($validator->fails()) {
            return ['success' => false, 'errors' => $validator->errors()->all()];
        }

        $deviceToken = DeviceToken::where('token', $request->token)->first();

        if ($deviceToken) {
            return ['success' => true, 'message' => 'Already exists'];
        }

        $deviceToken          = new DeviceToken();
        $deviceToken->user_id = auth()->user()->id;
        $deviceToken->token   = $request->token;
        $deviceToken->is_app  = Status::NO;
        $deviceToken->save();

        return ['success' => true, 'message' => 'Token saved successfully'];
    }

    public function downloadAttachment($fileHash)
    {
        $filePath = decrypt($fileHash);
        $extension = pathinfo($filePath, PATHINFO_EXTENSION);
        $title = slug(gs('site_name')) . '- attachments.' . $extension;
        try {
            $mimetype = mime_content_type($filePath);
        } catch (\Exception $e) {
            $notify[] = ['error', 'File does not exists'];
            return back()->withNotify($notify);
        }
        header('Content-Disposition: attachment; filename="' . $title);
        header("Content-Type: " . $mimetype);
        return readfile($filePath);
    }

    public function purchaseCard(Request $request)
    {

        $request->validate([
            'id' => 'required|exists:subcategories,id',
            'quantity' => 'required|gt:0|integer'
        ]);

        $user = auth()->user();
        $quantity = $request->quantity;

        $subcategory = Subcategory::where('id', $request->id)->whereHas('category', function ($q) {
            $q->active();
        })->whereHas('cards', function ($q) {
            $q->where('user_id', 0);
        })->first();

        if (!$subcategory) {
            $notify[] = ['error', 'Sorry, We do not have  available cards.'];
            return back()->withNotify($notify);
        }

        if ($subcategory->cards()->count() < $quantity) {
            $notify[] = ['error', 'Sorry, We do not have enough cards available to process your request.'];
            return back()->withNotify($notify);
        }

        $price = $subcategory->price * $quantity;

        if ($price > $user->balance) {
            $notify[] = ['error', 'Sorry, You do not have sufficient balance to make this purchase.'];
            return back()->withNotify($notify);
        }

        $trx = getTrx();

        $user->balance -= $price;
        $user->save();

       
        Card::where('subcategory_id', $request->id)
            ->where('user_id', 0)
            ->limit($quantity)->update([
                'user_id' => $user->id,
                'trx' => $trx,
                'purchased_at' => Carbon::now()
            ]);

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $price;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 0;
        $transaction->trx_type = '-';
        $transaction->details = 'Purchased ' . $quantity . ' ' . $subcategory->name . ' successfully';
        $transaction->trx =  $trx;
        $transaction->save();

        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = $user->username . ' has purchased ' . $subcategory->name;
        $adminNotification->click_url = urlPath('admin.users.card', $user->id);
        $adminNotification->save();

        notify($user, 'BUY_CARD', [
            'trx' => $trx,
            'price' => showAmount($price, currencyFormat: false),
            'currency' => gs('cur_text'),
            'purchased_at' => showDateTime(Carbon::now()),
            'category' => $subcategory->category->name,
            'subcategory' => $subcategory->name,
            'quantity' => $quantity,
            'post_balance' => showAmount($transaction->post_balance, currencyFormat: false),
        ]);

        $notify[] = ['success', ' Purchased successfully'];
        return to_route('user.card.all')->withNotify($notify);
    }

    public function cards()
    {
        $pageTitle = 'My Cards';
        $cards  = Card::where('user_id', auth()->id())->with('subcategory.category')->orderByDesc('id')->paginate(getPaginate());
        return view('Template::user.card', compact('pageTitle', 'cards'));
    }

    public function cardDetails($id)
    {
        $pageTitle = 'Card Details';
        $card  = Card::where('user_id', auth()->id())->where('id', $id)->with('subcategory.category')->firstOrFail();
        return view('Template::user.card_details', compact('pageTitle', 'card'));
    }
}
